diff -r 82fcd4bea972 src/bul.h
--- a/src/bul.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/bul.h	Fri Jan 11 17:02:25 2008 +0100
@@ -9,6 +9,9 @@
 #include "tqueue.h"
 #include "hash.h"
 #include "list.h"
+
+#define BULE_TABLE_MIN 1
+#define BULE_TABLE_MAX 251
 
 struct home_addr_info;
 
@@ -31,10 +34,16 @@ struct bulentry {
 	struct in6_addr hoa;
 	struct in6_addr coa;		/* care-of address of the sent BU */
 	int if_coa;
+	int if_tunnel;			/* MCoA: Tunnel iface for the BCE */
+	int table;			/* MCoA: Routing table where are 
+					   stored the routes */
+	int rules;			/* MCoA: if rules are installed for 
+					   this BULE */	
 	int type;                       /* BUL / NON_MIP_CN / UNREACH  */
 	uint16_t seq;			/* sequence number of the latest BU */
 	uint16_t flags;			/* BU send flags */
-	struct in6_addr last_coa;        /* Last good coa */      
+	uint16_t bid;			/* MCoA: Binding Identifier */
+	struct in6_addr last_coa;	/* Last good coa */      
 	struct timespec lastsent;
 	struct timespec lifetime;      	/* lifetime sent in this BU */
 	struct timespec delay;		/* call back time in ms*/
@@ -47,7 +56,11 @@ struct bulentry {
 	uint8_t use_alt_coa;            /* Whether to use alt. CoA option */
 	uint8_t dereg;                  /* for calculating BSA key */
 	uint8_t do_send_bu;             /* send bu / not send bu */
-
+	uint8_t priority;		/* MCoA: BID priority */
+	uint8_t home_block;		/* MCoA: NEMO_FWD_BLOCK, ... */  
+	uint8_t mcoa_dereg;		/* MCoA: if BCE needs to be 
+					   deregistered with a BU */
+ 
 	/* Information for return routability */
 	struct retrout_info rr;
 	uint8_t Kbm[HMAC_SHA1_KEY_SIZE];
@@ -84,7 +97,8 @@ enum {
 
 struct bulentry *bul_get(struct home_addr_info *hinfo,
 			 const struct in6_addr *our_addr,
-			 const struct in6_addr *peer_addr);
+			 const struct in6_addr *peer_addr,
+			 u_int16_t bid);
 
 int bul_add(struct bulentry *bule);
 
@@ -94,7 +108,11 @@ void bul_update_expire(struct bulentry *
 void bul_update_expire(struct bulentry *bule);
 
 int bul_iterate(struct hash *h, int (* func)(void *bule, void *arg), void *arg);
+int bul_iterate_in(struct in6_addr *peer_addr, 
+		   int (* func)(void *, void *), 
+		   void *arg);
 
+int bul_highest_priority(void *bule_v, void *best_bule_v);
 int bul_init(void);
 int bul_home_init(struct home_addr_info *home);
 void bul_home_cleanup(struct hash *bul);
@@ -102,7 +120,12 @@ void bul_cleanup(void);
 void bul_cleanup(void);
 void dump_bule(void *bule, void *os);
 struct bulentry *create_bule(const struct in6_addr *hoa,
-			     const struct in6_addr *cn_addr);
+			     const struct in6_addr *cn_addr,
+			     u_int16_t bid);
 void free_bule(struct bulentry *bule);
+int mcoa_bule_count(struct bulentry *bule);
+int mcoa_bule_dereg(struct bulentry *bule_v, int value);
+void bule_block_fwd(struct bulentry *bule);
+void bule_unblock_fwd(struct bulentry *bule);
 
 #endif
diff -r 82fcd4bea972 src/cn.c
--- a/src/cn.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/cn.c	Fri Jan 11 17:02:25 2008 +0100
@@ -67,7 +67,11 @@ static void cn_recv_dst_unreach(const st
 	if (icmp6_parse_data(ip6h, optlen, &laddr, &raddr) < 0)
 		return;
 
-	bce = bcache_get(laddr, raddr);
+	/* MCoA TODO2
+	 * Add MCoA support for the CN
+	 * MCOA_NO_BID must be replaced with the BUI's BID
+	 */
+	bce = bcache_get(laddr, raddr, MCOA_NO_BID);
 
 	if (bce == NULL) 
 		return;
@@ -76,7 +80,7 @@ static void cn_recv_dst_unreach(const st
 	if (bce->unreach > ICMP_ERROR_PERSISTENT_THRESHOLD &&
 	    bce->type != BCE_HOMEREG) {
 		bcache_release_entry(bce);
-		bcache_delete(laddr, raddr);
+		bcache_delete(laddr, raddr, MCOA_NO_BID);
 		dbg("BCE for %x:%x:%x:%x:%x:%x:%x:%x deleted "
 		    "due to receipt of ICMPv6 destination unreach\n", 
 		    NIP6ADDR(raddr));
@@ -156,6 +160,7 @@ void cn_recv_bu(const struct ip6_mh *mh,
 	struct in6_addr_bundle out;
 	struct ip6_mh_binding_update *bu;
 	struct ip6_mh_opt_nonce_index *non_ind;
+	struct ip6_mh_opt_bid *bid_opt = NULL;
 	struct bcentry *bce = NULL;
 	struct timespec lft;
 	int status, new = 0;
@@ -175,7 +180,18 @@ void cn_recv_bu(const struct ip6_mh *mh,
 
 	bu_flags = bu->ip6mhbu_flags;
 	non_ind = mh_opt(&bu->ip6mhbu_hdr, &mh_opts, IP6_MHOPT_NONCEID);
-	bce = bcache_get(out.src, out.dst);
+	/* MCoA TODO2
+	 * MCoA support for CN is not implemented yet
+	 * At the moment we ignore the BUs with BUI option
+	 */
+	if ((bid_opt = mh_opt(&bu->ip6mhbu_hdr, &mh_opts, IP6_MHOPT_BID))) {
+		dbg("Received BU with BUI sub-option, but CN doesn't "
+		    "support MCoA registration. BU skipped.\n");
+		status = IP6_MH_BAS_REG_NOT_ALLOWED;
+		goto send_nack;
+	}
+
+	bce = bcache_get(out.src, out.dst, MCOA_NO_BID);
 	if (bce) {
 		if ((bce->flags^bu_flags) & (IP6_MH_BU_HOME|IP6_MH_BU_MR)) {
 			/* H-bit or R-bit mismatch, flags changed */
@@ -219,7 +235,7 @@ void cn_recv_bu(const struct ip6_mh *mh,
 				goto send_nack;
 			}
 			/* else get rid of it */
-			bcache_delete(out.src, out.dst);
+			bcache_delete(out.src, out.dst, MCOA_NO_BID);
 		}
 	} else {
 		if (bu_flags & IP6_MH_BU_HOME) {
@@ -281,18 +297,18 @@ void cn_recv_bu(const struct ip6_mh *mh,
 		}
 		/* dereg, success */
 		bcache_release_entry(bce);
-		bcache_delete(out.src, out.dst);
+		bcache_delete(out.src, out.dst, MCOA_NO_BID);
 		status = IP6_MH_BAS_ACCEPTED;
 	}
 	if (bu_flags & IP6_MH_BU_ACK)
-		mh_send_ba(&out, status, 0, seqno, &lft, key, iif);
+		mh_send_ba(&out, status, 0, seqno, &lft, 0, 0, key, iif);
 	return;
 send_nack:
 	if (bce) {
 		bcache_release_entry(bce);
-		bcache_delete(out.src, out.dst);
+		bcache_delete(out.src, out.dst, MCOA_NO_BID);
 	}
-	mh_send_ba_err(&out, status, 0, seqno, pkey, iif);
+	mh_send_ba_err(&out, status, 0, seqno, 0, 0, pkey, iif);
 }
 
 static struct mh_handler cn_bu_handler =
diff -r 82fcd4bea972 src/conf.c
--- a/src/conf.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/conf.c	Fri Jan 11 17:02:25 2008 +0100
@@ -74,6 +74,7 @@ static void conf_version(void)
 {
 	fprintf(stderr,
 		"%s (%s) %s\n"
+		"With Multiple Care-of Addresses registration support\n"
 		"%s\n"
 		"This is free software; see the source for copying conditions.  There is NO\n"
 		"warranty; not even for MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.\n",
@@ -218,6 +219,7 @@ static void conf_default(struct mip6_con
 
 	/* HA options */
 	c->SendMobPfxAdvs = 1;
+	c->HaAcceptMCoAReg = 0;
 	c->SendUnsolMobPfxAdvs = 1;
 	c->MaxMobPfxAdvInterval = 86400; /* seconds */
 	c->MinMobPfxAdvInterval = 600; /* seconds */
@@ -317,8 +319,89 @@ void conf_show(struct mip6_config *c)
 	dbg("MinMobPfxAdvInterval = %u\n", c->MinMobPfxAdvInterval);
 	dbg("HaMaxBindingLife = %u\n", c->HaMaxBindingLife);
 	dbg("HaAcceptMobRtr = %s\n", CONF_BOOL_STR(c->HaAcceptMobRtr));
+	dbg("HaAcceptMCoAReg = %s\n", CONF_BOOL_STR(c->HaAcceptMCoAReg));
 
 	/* CN options */
 	dbg("DoRouteOptimizationCN = %s\n",
 	    CONF_BOOL_STR(c->DoRouteOptimizationCN));
 }
+
+/* 
+ * get_reliable_from_ifindex - return the reliability value 
+ * from the interface index
+ * @iif: the interface index
+ */ 
+int get_reliable_from_ifindex(int iif)
+{
+	struct list_head *list;
+
+	list_for_each(list, &conf.net_ifaces) {
+		struct net_iface *nif;
+		nif = list_entry(list, struct net_iface, list);
+		if (nif->ifindex == iif) {
+			if (is_if_mn(nif))
+				return nif->mn_if_reliable;
+			return -1;
+		}
+	}
+	return -1;
+}
+
+/* 
+ * get_bid_from_ifindex - return the bid from the interface index
+ * @iif: the interface index
+ */ 
+uint16_t get_bid_from_ifindex(int iif)
+{
+	struct list_head *list;
+
+	list_for_each(list, &conf.net_ifaces) {
+		struct net_iface *nif;
+		nif = list_entry(list, struct net_iface, list);
+		if (nif->ifindex == iif) {
+			if (is_if_mn(nif))
+				return nif->mn_if_bid;
+			return 0;
+		}
+	}
+	return 0;
+}
+
+/* 
+ * get_prio_from_bid - return the priority from the bid
+ * @bid: the bid of the interface
+ */ 
+uint8_t get_prio_from_bid(uint16_t bid)
+{
+	struct list_head *list;
+
+	list_for_each(list, &conf.net_ifaces) {
+		struct net_iface *nif;
+		nif = list_entry(list, struct net_iface, list);
+		if (nif->mn_if_bid == bid) {
+			if (is_if_mn(nif))
+				return nif->mn_if_bidprio;
+			return 0;
+		}
+	}
+	return 0;
+}
+
+/* 
+ * get_highest_prio - return the highest BID priority from the 
+ * interface list
+ */ 
+uint8_t get_highest_prio()
+{
+	struct list_head *list;
+	int priority = 0;
+
+	list_for_each(list, &conf.net_ifaces) {
+		struct net_iface *nif;
+		nif = list_entry(list, struct net_iface, list);
+		if (nif->mn_if_bidprio >= priority)
+			priority = nif->mn_if_bidprio;
+	}
+	return priority;
+}
+
diff -r 82fcd4bea972 src/conf.h
--- a/src/conf.h	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/conf.h	Fri Jan 11 17:02:25 2008 +0100
@@ -48,6 +48,7 @@ struct mip6_config {
 
 	/* HA options */
 	char HaAcceptMobRtr;
+	char HaAcceptMCoAReg;
 	char SendMobPfxAdvs;
 	char SendUnsolMobPfxAdvs;
 	unsigned int MaxMobPfxAdvInterval;
@@ -66,6 +67,9 @@ struct net_iface {
 	int is_rtr;
 	int mip6_if_entity;
 	int mn_if_preference;
+	uint16_t mn_if_bid;
+	uint8_t mn_if_bidprio;
+	int mn_if_reliable;
 };
 
 extern struct mip6_config conf;
@@ -119,6 +123,11 @@ int conf_parse(struct mip6_config *c, in
 
 void conf_show(struct mip6_config *c);
 
+int get_reliable_from_ifindex(int iif);
+uint16_t get_bid_from_ifindex(int iif);
+uint8_t get_prio_from_bid(uint16_t bid);
+uint8_t get_highest_prio();
+
 int yyparse(void);
 
 int yylex(void);
diff -r 82fcd4bea972 src/dhaad_mn.c
--- a/src/dhaad_mn.c	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/dhaad_mn.c	Fri Jan 11 17:02:25 2008 +0100
@@ -120,8 +120,9 @@ static void dhaad_resend(struct tq_elem 
 			pthread_rwlock_unlock(&mn_lock);
 			return;
 		}
-		t->dhaad_id = dhaad_send_request(hai->primary_coa.iif,
-						 &hai->primary_coa.addr,
+		assert(hai->current_coa);
+		t->dhaad_id = dhaad_send_request(hai->current_coa->iif,
+						 &hai->current_coa->addr,
 						 &hai->home_prefix,
 						 hai->home_plen,
 						 hai->mob_rtr?
@@ -146,8 +147,9 @@ static void _dhaad_start(struct home_add
 		if (hai->mob_rtr && !(hai->home_block & NEMO_RA_BLOCK))
 			xfrm_block_ra(hai);
 		t->dhaad_resends = 0;
-		t->dhaad_id = dhaad_send_request(hai->primary_coa.iif,
-						 &hai->primary_coa.addr,
+		assert(hai->current_coa);
+		t->dhaad_id = dhaad_send_request(hai->current_coa->iif,
+						 &hai->current_coa->addr,
 						 &hai->home_prefix,
 						 hai->home_plen,
 						 hai->mob_rtr?
diff -r 82fcd4bea972 src/gram.y
--- a/src/gram.y	Fri Jan 11 16:55:08 2008 +0100
+++ b/src/gram.y	Fri Jan 11 17:02:25 2008 +0100
@@ -47,15 +47,20 @@
 #include "util.h"
 #include "ipsec.h"
 #include "rtnl.h"
+#include "bul.h"
 
 struct net_iface ni = {
 	.mip6_if_entity = MIP6_ENTITY_NO,
 	.mn_if_preference = POL_MN_IF_DEF_PREFERENCE,
+	.mn_if_bid = POL_MN_IF_DEF_BID,
+	.mn_if_bidprio = POL_MN_IF_DEF_BID_PRIORITY,
+	.mn_if_reliable = POL_MN_IF_DEF_RELIABLE
 };
 	
 struct home_addr_info hai = {
 	.ro_policies = LIST_HEAD_INIT(hai.ro_policies),
-	.mob_net_prefixes = LIST_HEAD_INIT(hai.mob_net_prefixes)
+	.mob_net_prefixes = LIST_HEAD_INIT(hai.mob_net_prefixes),
+	.mcoa = LIST_HEAD_INIT(hai.mcoa)
 };
 
 LIST_HEAD(prefixes);
@@ -185,6 +190,14 @@ static void uerror(const char *fmt, ...)
 %token		ISMOBRTR
 %token		HASERVEDPREFIX
 %token		MOBRTRUSEEXPLICITMODE
+%token		HAACCEPTMCOAREG
+%token		MCOAREG
+%token		NOMCOAREG
+%token		BID
+%token		BIDPRIORITY
+%token		RELIABLE
+%token		REGMULTIPLECOA
+%token		IFMULTIPLECOA
 
 %token		INV_TOKEN
 
@@ -197,6 +210,7 @@ static void uerror(const char *fmt, ...)
 %type <addr>	mnropolicyaddr
 %type <bool>	dorouteopt
 %type <num>	bindaclpolval
+%type <num>	mcoapolval
 %type <num>	prefixlen
 %type <num>	mip6entity
 %type <bool>	xfrmaction
@@ -306,6 +320,10 @@ topdef		: MIP6ENTITY mip6entity ';'
 		{
 			conf.HaAcceptMobRtr = $2;
 		}
+		| HAACCEPTMCOAREG BOOL ';' 
+		{ 
+			conf.HaAcceptMCoAReg = $2;
+		}
 		| HASERVEDPREFIX prefixlistentry ';'
 		{
 			list_splice(&prefixes,
@@ -375,6 +393,9 @@ ifacedef	: QSTRING ifacesub
 			memset(&ni, 0, sizeof(struct net_iface));
 			ni.mip6_if_entity = MIP6_ENTITY_NO;
 			ni.mn_if_preference = POL_MN_IF_DEF_PREFERENCE;
+			ni.mn_if_bid = POL_MN_IF_DEF_BID;
+			ni.mn_if_bidprio = POL_MN_IF_DEF_BID_PRIORITY;
+			ni.mn_if_reliable = POL_MN_IF_DEF_RELIABLE;
 		}
 		;
 
@@ -392,7 +413,44 @@ ifaceopt	: IFTYPE mip6entity ';'
 		} 
 		| MNIFPREFERENCE NUMBER ';'
 		{
-			ni.mn_if_preference = $2;
+			if (ni.mn_if_bid) {
+				uerror("You cannot set MnIfPreference if BID "
+				       "is set. Use BidPriority instead.");
+				return -1;
+			}
+ 			ni.mn_if_preference = $2;
+		}
+		| BID NUMBER ';'
+		{
+			if (ni.mn_if_preference) {
+				uerror("If BID is set, you cannot set "
+				       "MnIfPreference. Use BidPriority instead.");
+				return -1;
+			}
+			if ($2 < BULE_TABLE_MIN || $2 > BULE_TABLE_MAX) {
+				uerror("BID error (%d <= Bid <= %d)",
+					BULE_TABLE_MIN, BULE_TABLE_MAX);
+				return -1;
+			}
+			ni.mn_if_bid = $2;
+		}
+		| BIDPRIORITY NUMBER ';'
+		{
+			if (ni.mn_if_preference) {
+				uerror("You cannot set BidPriority if "
+				       "MnIfPreference is set.");
+				return -1;
+			}		
+			if ($2 < 1 || $2 > 255) {
+				uerror("BidPriotity error "
+				       "(%d <= BidPriority <= %d)",1, 255);
+				return -1;
+			}
+			ni.mn_if_bidprio = $2;
+		}
+		| RELIABLE BOOL ';'
+		{
+			ni.mn_if_reliable = $2;
 		}
 		;
 
@@ -432,15 +490,28 @@ linksub		: QSTRING '{' linkdefs '}'
 			INIT_LIST_HEAD(&nhai->ro_policies);
 			INIT_LIST_HEAD(&nhai->ha_list.home_agents);
 			INIT_LIST_HEAD(&nhai->mob_net_prefixes);
+			INIT_LIST_HEAD(&nhai->mcoa);
 			nhai->ha_list.dhaad_id = -1;
 			list_splice(&hai.ro_policies, &nhai->ro_policies);
 			list_splice(&hai.mob_net_prefixes,
 				    &nhai->mob_net_prefixes);
+			list_splice(&hai.mcoa, &nhai->mcoa);
+			if (!hai.reg_mcoa) {
+				/* If MCoA registration is not used, we
+				 * initialize nhai->current_coa
+				 */
+				nhai->current_coa = malloc(sizeof(struct mn_addr)); 
+				if (nhai->current_coa == NULL) {
+					uerror("out of memory");
+					return -1;
+				}
+			}
 			list_add_tail(&nhai->list, &conf.home_addrs);
 
 			memset(&hai, 0, sizeof(struct home_addr_info));
 			INIT_LIST_HEAD(&hai.ro_policies);
 			INIT_LIST_HEAD(&hai.mob_net_prefixes);
+			INIT_LIST_HEAD(&hai.mcoa);
 		}
 		;
 
@@ -468,6 +539,11 @@ linkdef		: HOMEAGENTADDRESS ADDR ';'
 			ipv6_addr_prefix(&hai.home_prefix, &$2, $4);
 			hai.home_plen = $4;
 		}
+		| REGMULTIPLECOA BOOL ';'
+		{
+			hai.reg_mcoa = $2;
+		}
+		| IFMULTIPLECOA iflist ';'
 		;
 
 homeaddress	: homeaddrdef prefixlistsub
@@ -695,7 +771,12 @@ bindaclpolval	: BOOL
 		| NUMBER { $$ = $1; }
 		;
 
-bindaclpolicy	: ADDR prefixlistsub bindaclpolval
+mcoapolval	: MCOAREG { $$ = 1; }
+		| NOMCOAREG { $$ = 0; }
+		| '' { $$ = 0; }
+		;
+
+bindaclpolicy	: ADDR prefixlistsub mcoapolval bindaclpolval
 		{
 			bae = malloc(sizeof(struct policy_bind_acl_entry));
 			if (bae == NULL) {
@@ -707,7 +788,8 @@ bindaclpolicy	: ADDR prefixlistsub binda
 			bae->plen = 128;
 			INIT_LIST_HEAD(&bae->mob_net_prefixes);
 			bae->mnp_count = mv_prefixes(&bae->mob_net_prefixes);
-			bae->bind_policy = $3;
+			bae->mcoa_reg = $3;
+			bae->bind_policy = $4;
 			list_add_tail(&bae->list, &conf.bind_acl);
 		}
 		;
@@ -745,4 +827,58 @@ prefixlistentry	: ADDR '/' prefixlen
 			list_add_tail(&p->list, &prefixes);
 		}
 		;
+		
+iflist		: iflistentry
+		| iflist ',' iflistentry
+		;
+
+iflistentry	: QSTRING
+		{
+			struct mn_addr *mncoa;
+			struct list_head *l;
+			int declared = 0, bid = 0;
+			
+			/* Check that this interface has been  
+			 * previously declared as "Interface" */
+			list_for_each(l, &conf.net_ifaces) {
+				struct net_iface *ni;
+				ni = list_entry(l, struct net_iface,
+						list);
+
+				if(if_nametoindex($1) == ni->ifindex) {
+					declared = 1;
+					bid = ni->mn_if_bid;
+					break;
+				}
+			}
+
+			if(!declared) {
+				uerror("Interface %s has not been "
+					"declared as Interface\n", $1);
+				return -1;
+			}
+
+			if(!bid) {
+				uerror("Interface %s has no BID "
+					"although you declared it in "
+					"IfMultipleCoA\n", $1);
+				return -1;
+			}
+			
+			mncoa = malloc(sizeof(struct mn_addr));
+			if (mncoa == NULL) {
+				fprintf(stderr, "%s: out of memory\n", 
+					__FUNCTION__);
+				return -1;
+			}
+			memset(mncoa, 0, sizeof(struct mn_addr));
+			if ((mncoa->iif = if_nametoindex($1)) == 0) {
+				fprintf(stderr, "%s: %s is not a valid "
+					"interface name\n", __FUNCTION__, $1);
+				return -1;
+			}
+			free($1);
+			list_add_tail(&mncoa->list, &hai.mcoa);
+		}
+		;
 %%
